diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
index 81aa3c093..01138b4ce 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
@@ -2,6 +2,7 @@ package net.minecraft.core.entity.projectile;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.phys.HitResult;
@@ -10,26 +11,25 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.primitives.AABBdc;
 
-public class ProjectileArrow extends Projectile
-{
+public class ProjectileArrow extends Projectile {
     public static final int TYPE_NORMAL = 0;
     public static final int TYPE_PURPLE = 1;
     public static final int TYPE_GOLDEN = 2;
     protected int mobsHit = 0;
-    protected int xTile = -1;
-    protected int yTile = -1;
-    protected int zTile = -1;
-    protected int inTile = 0;
+    protected @Nullable TilePos tilePos = null;
+    protected @Nullable Block<?> inTile = null;
     public int shake = 0;
     protected int inData = 0;
     protected int arrowType;
     protected ItemStack stack = new ItemStack(Items.AMMO_ARROW);
-    
+
     /*
      * I have reverted these to not be synced in multiplayer,
      * because arrows shot into the ground by players were very jittery.
@@ -39,238 +39,221 @@ public class ProjectileArrow extends Projectile
     protected boolean inGround = false;
     protected boolean doesArrowBelongToPlayer = false;
 
-	public ProjectileArrow(World world) {
-		this(world, TYPE_NORMAL);
-	}
-	
-    public ProjectileArrow(World world, int arrowType)
-    {
+    public ProjectileArrow(@NotNull World world) {
+        this(world, TYPE_NORMAL);
+    }
+
+    public ProjectileArrow(@NotNull World world, int arrowType) {
         super(world);
         this.arrowType = arrowType;
     }
 
-    public ProjectileArrow(World world, double d, double d1, double d2, int arrowType)
-    {
-        super(world, d, d1, d2);
+    public ProjectileArrow(@NotNull World world, double x, double y, double z, int arrowType) {
+        super(world, x, y, z);
         this.arrowType = arrowType;
     }
 
-    public ProjectileArrow(World world, Mob entityliving, boolean doesArrowBelongToPlayer, int arrowType)
-    {
-        super(world, entityliving);
+    public ProjectileArrow(@NotNull World world, @NotNull Mob owner, boolean doesArrowBelongToPlayer, int arrowType) {
+        super(world, owner);
         setDoesArrowBelongToPlayer(doesArrowBelongToPlayer);
         this.arrowType = arrowType;
     }
 
     @Override
-	protected void initProjectile()
-    {
+    protected void initProjectile() {
         super.initProjectile();
-        damage = 5;
+        this.damage = 5;
     }
-    
+
     public void setDoesArrowBelongToPlayer(boolean flag) {
-    	this.doesArrowBelongToPlayer = flag;
+        this.doesArrowBelongToPlayer = flag;
     }
-    
+
     public boolean arrowBelongsToPlayer() {
-    	return doesArrowBelongToPlayer;
+        return this.doesArrowBelongToPlayer;
     }
-    
+
     public void setGrounded(boolean flag) {
-    	this.inGround = flag;
+        this.inGround = flag;
     }
-    
+
     public boolean isGrounded() {
-    	return inGround;
+        return this.inGround;
     }
-    
+
     @Override
-	public void lerpMotion(double xd, double yd, double zd)
-    {
+    public void lerpMotion(double xd, double yd, double zd) {
         this.xd = xd;
         this.yd = yd;
         this.zd = zd;
-        if(xRotO == 0.0F && yRotO == 0.0F)
-        {
+        if (this.xRotO == 0.0F && this.yRotO == 0.0F) {
             float f = MathHelper.sqrt(xd * xd + zd * zd);
-            yRot = (float) ((Math.atan2(xd, zd) * 180D) / Math.PI);
-            xRot = (float) ((Math.atan2(yd, f) * 180D) / Math.PI);
-            xRotO = xRot;
-            yRotO = yRot;
-            moveTo(x, y, z, yRot, xRot);
-            ticksInGround = 0;
+            this.yRot = (float) ((Math.atan2(xd, zd) * 180D) / Math.PI);
+            this.xRot = (float) ((Math.atan2(yd, f) * 180D) / Math.PI);
+            this.xRotO = this.xRot;
+            this.yRotO = this.yRot;
+            moveTo(this.x, this.y, this.z, this.yRot, this.xRot);
+            this.ticksInGround = 0;
         }
     }
 
     @Override
-	public void tick()
-    {
-        if(shake > 0)
-        {
-            shake--;
+    public void tick() {
+        if (this.shake > 0) {
+            this.shake--;
         }
-        if(xRotO == 0.0F && yRotO == 0.0F)
-        {
-            float f = MathHelper.sqrt(xd * xd + zd * zd);
-            yRotO = yRot = (float)((Math.atan2(xd, zd) * 180D) / Math.PI);
-            xRotO = xRot = (float)((Math.atan2(yd, f) * 180D) / Math.PI);
+        if (this.xRotO == 0.0F && this.yRotO == 0.0F) {
+            float f = MathHelper.sqrt(this.xd * this.xd + this.zd * this.zd);
+            this.yRotO = this.yRot = (float) ((Math.atan2(this.xd, this.zd) * 180D) / Math.PI);
+            this.xRotO = this.xRot = (float) ((Math.atan2(this.yd, f) * 180D) / Math.PI);
         }
-        Block<?> block = world.getBlock(xTile, yTile, zTile);
-        if(block != null)
-        {
-            AABB aabb = block.getCollisionBoundingBoxFromPool(world, xTile, yTile, zTile);
-            if(aabb != null && aabb.contains(Vec3.fromPool(x, y, z)))
-            {
-                setGrounded(true);
+        if (this.tilePos != null) {
+            Block<?> block = this.world.getBlock(this.tilePos);
+            if (block != null) {
+                AABBdc aabb = block.getCollisionAABB(this.world, this.tilePos);
+                if (aabb != null && aabb.containsPoint(new Vector3d(this.x, this.y, this.z))) {
+                    setGrounded(true);
+                }
             }
         }
-        if(isGrounded())
-        {
-            int id = world.getBlockId(xTile, yTile, zTile);
-            int meta = world.getBlockMetadata(xTile, yTile, zTile);
-            if(id != inTile || meta != inData)
-            {
+        if (isGrounded() && this.tilePos != null) {
+            Block<?> b = this.world.getBlock(this.tilePos);
+            int meta = this.world.getBlockData(this.tilePos);
+            if (b != this.inTile || meta != this.inData) {
                 setGrounded(false);
-                xd *= random.nextFloat() * 0.2D;
-                yd *= random.nextFloat() * 0.2D;
-                zd *= random.nextFloat() * 0.2D;
-                ticksInGround = 0;
-                ticksInAir = 0;
+                this.xd *= this.random.nextFloat() * 0.2D;
+                this.yd *= this.random.nextFloat() * 0.2D;
+                this.zd *= this.random.nextFloat() * 0.2D;
+                this.ticksInGround = 0;
+                this.ticksInAir = 0;
                 return;
             }
-            ticksInGround++;
-            if(ticksInGround == 1200)
-            {
+            this.ticksInGround++;
+            if (this.ticksInGround == 1200) {
                 remove();
             }
             return;
-        }
-        else if(this instanceof ProjectileArrowGolden)
-        {
-            world.spawnParticle("arrowtrail", x, y, z, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D, 0);
-            world.spawnParticle("arrowtrail", x + xd * 0.5D, y + yd * 0.5D, z + zd * 0.5D, xd * 0.05D, yd * 0.05D - 0.1D, zd * 0.05D, 0);
+        } else if (this instanceof ProjectileArrowGolden) {
+            this.world.spawnParticle("arrowtrail", this.x, this.y, this.z, this.xd * 0.05D, this.yd * 0.05D - 0.1D, this.zd * 0.05D, 0);
+            this.world.spawnParticle("arrowtrail", this.x + this.xd * 0.5D, this.y + this.yd * 0.5D, this.z + this.zd * 0.5D, this.xd * 0.05D, this.yd * 0.05D - 0.1D, this.zd * 0.05D, 0);
         }
         super.tick();
     }
-    public HitResult getHitResult(){
-        Vec3 oldPosition = Vec3.fromPool(x, y, z);
-        Vec3 newPosition = Vec3.fromPool(x + xd, y + yd, z + zd);
-        return world.checkBlockCollisionBetweenPoints(oldPosition, newPosition, false, true, false);
+
+    public HitResult getHitResult() {
+        Vector3d oldPosition = new Vector3d(this.x, this.y, this.z);
+        Vector3d newPosition = new Vector3d(this.x + this.xd, this.y + this.yd, this.z + this.zd);
+        return this.world.checkBlockCollisionBetweenPoints(oldPosition, newPosition, false, true, false);
     }
-    public void onHit(@NotNull HitResult hitResult){
-        if(hitResult instanceof HitResult.Entity hitEntity)
-        {
-            if(hitEntity.entity.hurt(this.owner, damage, DamageType.COMBAT))
-            {
-                if(this.isOnFire())
+
+    public void onHit(@NotNull HitResult hitResult) {
+        if (hitResult instanceof HitResult.Entity hitEntity) {
+            if (hitEntity.entity.hurt(this.owner, this.damage, DamageType.COMBAT)) {
+                if (this.isOnFire())
                     hitEntity.entity.fireHurt();
-                if(!world.isClientSide) {
-                	world.playSoundAtEntity(null, this, "random.drr", 1.0F, 1.2F / (random.nextFloat() * 0.2F + 0.9F));
+                if (!this.world.isClientSide) {
+                    this.world.playSoundAtEntity(null, this, "random.drr", 1.0F, 1.2F / (this.random.nextFloat() * 0.2F + 0.9F));
                 }
-                if(!(this instanceof ProjectileArrowGolden))
-                {
+                if (!(this instanceof ProjectileArrowGolden)) {
                     remove();
                 } else {
-                    if (owner instanceof Player && ++mobsHit >= 3) {
-                        ((Player) owner).addStat(Achievements.TRIPLE_HIT, 1);
+                    if (this.owner instanceof Player && ++this.mobsHit >= 3) {
+                        ((Player) this.owner).addStat(Achievements.TRIPLE_HIT, 1);
                     }
                 }
-            } else if(!(this instanceof ProjectileArrowGolden))
-            {
-                xd *= -0.1D;
-                yd *= -0.1D;
-                zd *= -0.1D;
-                yRot += 180F;
-                yRotO += 180F;
-                ticksInAir = 0;
+            } else if (!(this instanceof ProjectileArrowGolden)) {
+                this.xd *= -0.1D;
+                this.yd *= -0.1D;
+                this.zd *= -0.1D;
+                this.yRot += 180F;
+                this.yRotO += 180F;
+                this.ticksInAir = 0;
             }
-        } else if (hitResult instanceof HitResult.Tile hitTile)
-        {
-            xTile = hitTile.tilePos.x;
-            yTile = hitTile.tilePos.y;
-            zTile = hitTile.tilePos.z;
-            inTile = world.getBlockId(hitTile.tilePos);
-            inData = world.getBlockData(hitTile.tilePos);
-            xd = (float)(hitResult.location.x - x);
-            yd = (float)(hitResult.location.y - y);
-            zd = (float)(hitResult.location.z - z);
-            float f1 = MathHelper.sqrt(xd * xd + yd * yd + zd * zd);
-            x -= (xd / (double)f1) * 0.05D;
-            y -= (yd / (double)f1) * 0.05D;
-            z -= (zd / (double)f1) * 0.05D;
+        } else if (hitResult instanceof HitResult.Tile hitTile) {
+            this.tilePos = new TilePos(hitTile.tilePos);
+            this.inTile = this.world.getBlock(hitTile.tilePos);
+            this.inData = this.world.getBlockData(hitTile.tilePos);
+            this.xd = (float) (hitResult.location.x() - this.x);
+            this.yd = (float) (hitResult.location.y() - this.y);
+            this.zd = (float) (hitResult.location.z() - this.z);
+            float f1 = MathHelper.sqrt(this.xd * this.xd + this.yd * this.yd + this.zd * this.zd);
+            this.x -= (this.xd / (double) f1) * 0.05D;
+            this.y -= (this.yd / (double) f1) * 0.05D;
+            this.z -= (this.zd / (double) f1) * 0.05D;
             inGroundAction();
         }
     }
-    
-    protected void inGroundAction()
-    {
-    	if(world.isClientSide) {
+
+    protected void inGroundAction() {
+        if (this.world.isClientSide) {
             setGrounded(true);
-            shake = 7;
+            this.shake = 7;
             return;
-    	}
+        }
         if (!arrowBelongsToPlayer()) {
-            world.playSoundAtEntity(null, this, "random.drr", 1.0F, 1.2F / (random.nextFloat() * 0.2F + 0.9F));
-            for(int j = 0; j < 4; j++)
-            {
-                world.spawnParticle("item", x, y, z, 0.0, 0.0D, 0.0D, Items.AMMO_ARROW.id);
+            this.world.playSoundAtEntity(null, this, "random.drr", 1.0F, 1.2F / (this.random.nextFloat() * 0.2F + 0.9F));
+            for (int j = 0; j < 4; j++) {
+                this.world.spawnParticle("item", this.x, this.y, this.z, 0.0, 0.0D, 0.0D, Items.AMMO_ARROW.id);
             }
             remove();
             return;
         }
-        world.playSoundAtEntity(null, this, "random.drr", 1.0F, 1.2F / (random.nextFloat() * 0.2F + 0.9F));
+        this.world.playSoundAtEntity(null, this, "random.drr", 1.0F, 1.2F / (this.random.nextFloat() * 0.2F + 0.9F));
         setGrounded(true);
-        shake = 7;
+        this.shake = 7;
     }
 
-    public int getArrowType(){
-        return arrowType;
+    public int getArrowType() {
+        return this.arrowType;
     }
 
     @Override
-	public void addAdditionalSaveData(@NotNull CompoundTag tag)
-    {
+    public void addAdditionalSaveData(@NotNull CompoundTag tag) {
         super.addAdditionalSaveData(tag);
-        tag.putShort("xTile", (short) xTile);
-        tag.putShort("yTile", (short) yTile);
-        tag.putShort("zTile", (short) zTile);
-        tag.putShort("inTile", (short) inTile);
-        tag.putByte("shake", (byte) shake);
-        tag.putByte("inData", (byte) inData);
-        tag.putByte("inGround", (byte)(isGrounded() ? 1 : 0));
+        if (this.tilePos != null) {
+            tag.putInt("tilePosX", this.tilePos.x);
+            tag.putInt("tilePosY", this.tilePos.x);
+            tag.putInt("tilePosZ", this.tilePos.x);
+        }
+        if (this.inTile != null) {
+            tag.putShort("inTile", (short) this.inTile.id());
+        }
+        tag.putByte("shake", (byte) this.shake);
+        tag.putByte("inData", (byte) this.inData);
+        tag.putByte("inGround", (byte) (isGrounded() ? 1 : 0));
         tag.putBoolean("player", arrowBelongsToPlayer());
     }
 
     @Override
-	public void readAdditionalSaveData(@NotNull CompoundTag tag)
-    {
+    public void readAdditionalSaveData(@NotNull CompoundTag tag) {
         super.readAdditionalSaveData(tag);
-        xTile = tag.getShort("xTile");
-        yTile = tag.getShort("yTile");
-        zTile = tag.getShort("zTile");
-        inTile = tag.getShort("inTile") & 0x3fff;
-        shake = tag.getByte("shake") & 0xff;
-        inData = tag.getByte("inData") & 0xff;
+        if (tag.containsKey("xTile") && tag.containsKey("yTile") && tag.containsKey("zTile")) {
+            this.tilePos = new TilePos(tag.getShort("xTile"), tag.getShort("yTile"), tag.getShort("zTile"));
+        } else if (tag.containsKey("tilePosX") && tag.containsKey("tilePosY") && tag.containsKey("tilePosZ")) {
+            this.tilePos = new TilePos(tag.getInteger("tilePosX"), tag.getInteger("tilePosY"), tag.getInteger("tilePosZ"));
+        }
+
+        if (tag.containsKey("inTile")) {
+            this.inTile = Blocks.getBlock(tag.getShort("inTile") & 0x3fff);
+        }
+        this.shake = tag.getByte("shake") & 0xff;
+        this.inData = tag.getByte("inData") & 0xff;
         setGrounded(tag.getByte("inGround") == 1);
         setDoesArrowBelongToPlayer(tag.getBoolean("player"));
     }
 
     @Override
-	public void playerTouch(Player player)
-    {
-        if(world.isClientSide)
-        {
+    public void playerTouch(Player player) {
+        if (this.world.isClientSide) {
             return;
         }
-        if(isGrounded() && arrowBelongsToPlayer() && shake <= 0)
-        {
-        	player.inventory.insertItem(stack, true);
-        	if(stack.stackSize <= 0) {
-                world.playSoundAtEntity(player, this, "item.pickup", 1F, ((random.nextFloat() - random.nextFloat()) * 0.7F + 1.0F) * 4.0F);
-                player.onItemPickup(this, stack);
+        if (isGrounded() && arrowBelongsToPlayer() && this.shake <= 0) {
+            player.inventory.insertItem(this.stack, true);
+            if (this.stack.stackSize <= 0) {
+                this.world.playSoundAtEntity(player, this, "item.pickup", 1F, ((this.random.nextFloat() - this.random.nextFloat()) * 0.7F + 1.0F) * 4.0F);
+                player.onItemPickup(this, this.stack);
                 remove();
-        	}
+            }
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
index cf88d93cd..214b20130 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
@@ -6,131 +6,122 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
 
 import java.util.List;
 
-public class ProjectileCannonballBouncy extends ProjectileCannonball
-{
+public class ProjectileCannonballBouncy extends ProjectileCannonball {
     private int fuse = 50;
 
-    public ProjectileCannonballBouncy(World world, Mob owner)
-    {
+    public ProjectileCannonballBouncy(World world, Mob owner) {
         super(world, owner);
-        x += xd;
-        y += yd;
-        z += zd;
-        setHeading(xd, yd, zd, 0.75F, 0.0F);
+        this.x += this.xd;
+        this.y += this.yd;
+        this.z += this.zd;
+        setHeading(this.xd, this.yd, this.zd, 0.75F, 0.0F);
         this.defaultGravity = 0.06f;
     }
 
-    public ProjectileCannonballBouncy(World world, double x, double y, double z)
-    {
+    public ProjectileCannonballBouncy(World world, double x, double y, double z) {
         super(world, x, y, z);
         this.defaultGravity = 0.06f;
     }
 
     @Override
-    public void tick()
-    {
+    public void tick() {
         baseTick();
-        if(xRotO == 0.0F && yRotO == 0.0F)
-        {
-            float f = MathHelper.sqrt(xd * xd + zd * zd);
-            yRotO = yRot = (float)((Math.atan2(xd, zd) * 180D) / Math.PI);
-            xRotO = xRot = (float)((Math.atan2(yd, f) * 180D) / Math.PI);
+        if (this.xRotO == 0.0F && this.yRotO == 0.0F) {
+            float f = MathHelper.sqrt(this.xd * this.xd + this.zd * this.zd);
+            this.yRotO = this.yRot = (float) ((Math.atan2(this.xd, this.zd) * 180D) / Math.PI);
+            this.xRotO = this.xRot = (float) ((Math.atan2(this.yd, f) * 180D) / Math.PI);
         }
 
-        float velocity = MathHelper.sqrt(xd * xd + yd * yd + zd * zd);
+        float velocity = MathHelper.sqrt(this.xd * this.xd + this.yd * this.yd + this.zd * this.zd);
 
         // Check for block collision
-        Vec3 currentPos = Vec3.fromPool(x, y, z);
-        Vec3 nextPos = Vec3.fromPool(x + xd, y + yd - 0.25f, z + zd);
-        HitResult hit = world.checkBlockCollisionBetweenPoints(currentPos, nextPos, false, true, false);
-        if(hit != null)
-        {
-            if (hit instanceof HitResult.Tile hitTile)
-            {
+        Vector3dc currentPos = new Vector3d(this.x, this.y, this.z);
+        Vector3dc nextPos = new Vector3d(this.x + this.xd, this.y + this.yd - 0.25f, this.z + this.zd);
+        HitResult hit = this.world.checkBlockCollisionBetweenPoints(currentPos, nextPos, false, true, false);
+        if (hit != null) {
+            if (hit instanceof HitResult.Tile hitTile) {
                 float bounceAxisScale = 0.4f;
                 float otherAxisScale = 0.6f;
                 float minVelocity = 0.2f;
                 Side side = hitTile.side;
-                if (side == Side.TOP && (Math.abs(yd) < 0.25f || velocity < minVelocity))
-                {
-                    yd = 0f;
-                    y = hitTile.tilePos.y + 1f + 0.25f;
-                    xd = 0f;
-                    zd = 0f;
+                if (side == Side.TOP && (Math.abs(this.yd) < 0.25f || velocity < minVelocity)) {
+                    this.yd = 0f;
+                    this.y = hitTile.tilePos.y() + 1f + 0.25f;
+                    this.xd = 0f;
+                    this.zd = 0f;
                     return;
                 }
-                if (side.getAxis() == Axis.Y)
-                {
-                    yd = -yd * bounceAxisScale;
-                    xd *= otherAxisScale;
-                    zd *= otherAxisScale;
-                    world.playSoundAtEntity(null, this, "random.explode", 0.25f * velocity, 2.0f);
+                if (side.getAxis() == Axis.Y) {
+                    this.yd = -this.yd * bounceAxisScale;
+                    this.xd *= otherAxisScale;
+                    this.zd *= otherAxisScale;
+                    this.world.playSoundAtEntity(null, this, "random.explode", 0.25f * velocity, 2.0f);
                 }
-                if (side.getAxis() == Axis.X)
-                {
-                    xd = -xd * bounceAxisScale;
-                    yd *= otherAxisScale;
-                    zd *= otherAxisScale;
-                    world.playSoundAtEntity(null, this, "random.explode", 0.25f * velocity, 2.0f);
+                if (side.getAxis() == Axis.X) {
+                    this.xd = -this.xd * bounceAxisScale;
+                    this.yd *= otherAxisScale;
+                    this.zd *= otherAxisScale;
+                    this.world.playSoundAtEntity(null, this, "random.explode", 0.25f * velocity, 2.0f);
                 }
-                if (side.getAxis() == Axis.Z)
-                {
-                    zd = -zd * bounceAxisScale;
-                    xd *= otherAxisScale;
-                    yd *= otherAxisScale;
-                    world.playSoundAtEntity(null, this, "random.explode", 0.25f * velocity, 2.0f);
+                if (side.getAxis() == Axis.Z) {
+                    this.zd = -this.zd * bounceAxisScale;
+                    this.xd *= otherAxisScale;
+                    this.yd *= otherAxisScale;
+                    this.world.playSoundAtEntity(null, this, "random.explode", 0.25f * velocity, 2.0f);
                 }
             }
         }
 
         // Check for entity collision
-        List<Entity> collidingEntities = world.getEntitiesWithinAABBExcludingEntity(this, this.bb.cloneMove(xd, yd, zd));
-        if ((collidingEntities != null && collidingEntities.size() > 0) || fuse <= 0)
-        {
-            if (!((collidingEntities != null && collidingEntities.size() == 1) && collidingEntities.get(0) == owner && tickCount < 4))
-            {
-                world.createExplosion(owner, x, y + bbHeight/2, z, 1.5F, false, true);
+        List<Entity> collidingEntities = this.world.getEntitiesWithinAABBExcludingEntity(this, this.bb.translate(this.xd, this.yd, this.zd, new AABBd()));
+        if (!collidingEntities.isEmpty() || this.fuse <= 0) {
+            if (!(collidingEntities.size() == 1 && collidingEntities.get(0) == this.owner && this.tickCount < 4)) {
+                this.world.createExplosion(this.owner, this.x, this.y + this.bbHeight / 2, this.z, 1.5F, false, true);
                 remove();
                 return;
             }
         }
 
         // Update position
-        x += xd;
-        y += yd;
-        z += zd;
+        this.x += this.xd;
+        this.y += this.yd;
+        this.z += this.zd;
 
-        float velocityHorizontal = MathHelper.sqrt(xd * xd + zd * zd);
-        yRot = (float)((Math.atan2(xd, zd) * 180D) / Math.PI);
-        for(xRot = (float)((Math.atan2(yd, velocityHorizontal) * 180D) / Math.PI); xRot - xRotO < -180F; xRotO -= 360F) { }
-        for(; xRot - xRotO >= 180F; xRotO += 360F) { }
-        for(; yRot - yRotO < -180F; yRotO -= 360F) { }
-        for(; yRot - yRotO >= 180F; yRotO += 360F) { }
-        xRot = xRotO + (xRot - xRotO) * 0.2F;
-        yRot = yRotO + (yRot - yRotO) * 0.2F;
+        float velocityHorizontal = MathHelper.sqrt(this.xd * this.xd + this.zd * this.zd);
+        this.yRot = (float) ((Math.atan2(this.xd, this.zd) * 180D) / Math.PI);
+        for (this.xRot = (float) ((Math.atan2(this.yd, velocityHorizontal) * 180D) / Math.PI); this.xRot - this.xRotO < -180F; this.xRotO -= 360F) {
+        }
+        for (; this.xRot - this.xRotO >= 180F; this.xRotO += 360F) {
+        }
+        for (; this.yRot - this.yRotO < -180F; this.yRotO -= 360F) {
+        }
+        for (; this.yRot - this.yRotO >= 180F; this.yRotO += 360F) {
+        }
+        this.xRot = this.xRotO + (this.xRot - this.xRotO) * 0.2F;
+        this.yRot = this.yRotO + (this.yRot - this.yRotO) * 0.2F;
         float deceleration = 0.99F;
         float gravity = 0.06F;
-        if(isInWater())
-        {
-            for(int i = 0; i < 4; i++)
-            {
+        if (isInWater()) {
+            for (int i = 0; i < 4; i++) {
                 double particleDistance = 0.25D;
-                world.spawnParticle("bubble", x - xd * particleDistance, y - yd * particleDistance, z - zd * particleDistance, xd, yd, zd, 0);
+                this.world.spawnParticle("bubble", this.x - this.xd * particleDistance, this.y - this.yd * particleDistance, this.z - this.zd * particleDistance, this.xd, this.yd, this.zd, 0);
             }
 
             deceleration = 0.8F;
         }
-        world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D, 0);
-        xd *= deceleration;
-        yd *= deceleration;
-        zd *= deceleration;
-        yd -= gravity;
-        setPos(x, y, z);
-        fuse--;
+        this.world.spawnParticle("largesmoke", this.x, this.y, this.z, 0.0D, 0.0D, 0.0D, 0);
+        this.xd *= deceleration;
+        this.yd *= deceleration;
+        this.zd *= deceleration;
+        this.yd -= gravity;
+        setPos(this.x, this.y, this.z);
+        this.fuse--;
     }
 }
